<?php

namespace Drupal\entity_model\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * The Model attribute.
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class Model extends Plugin {

  /**
   * Constructs a Model attribute.
   *
   * @param string $entity_type
   *   The entity type ID.
   * @param string|null $bundle
   *   (optional) The entity bundle.
   */
  public function __construct(
    public readonly string $entity_type,
    public readonly ?string $bundle = NULL,
  ) {
  }

  /**
   * {@inheritdoc}
   */
  public function getId(): string {
    if (isset($this->bundle)) {
      return implode('.', [
        $this->entity_type,
        $this->bundle,
      ]);
    }

    return $this->entity_type;
  }

}
